package {

	import Box2DAS.Dynamics.ContactEvent;

	import com.citrusengine.core.CitrusObject;
	import com.citrusengine.core.State;
	import com.citrusengine.objects.platformer.Sensor;
	import com.citrusengine.physics.Box2D;
	import com.citrusengine.utils.ObjectMaker;

	import flash.display.MovieClip;

	/**
	 * @author Aymeric
	 */
	public class GameState extends State {

		private var _level:MovieClip;

		public function GameState(level:MovieClip) {

			super();
			_level = level;
		}

		override public function initialize():void {

			super.initialize();

			var box2D:Box2D = new Box2D("Box2D");
			add(box2D);
			box2D.visible = true;

			ObjectMaker.FromMovieClip(_level);

			var ball:Ball = Ball(getFirstObjectByType(Ball));
			ball.gravity = 0;
			ball.onEndContact.add(_takeBrick);

			var sensor:Sensor = Sensor(getFirstObjectByType(Sensor));
			sensor.onBeginContact.add(_resetLevel);

			var bricks:Vector.<CitrusObject> = getObjectsByType(Brick);
			for each (var brick:Brick in bricks) {
				brick.onEndContact.add(_takeBrick);
			}
		}

		private function _takeBrick(cEvt:ContactEvent):void {

			if (cEvt.other.GetBody().GetUserData() is Brick) {
				remove(cEvt.other.GetBody().GetUserData());
				this.dispatchEvent(new GameEvent(GameEvent.TAKE_BRICK));
			}
		}

		private function _resetLevel(cEvt:ContactEvent):void {

			if (cEvt.other.GetBody().GetUserData() is Ball) {
				this.dispatchEvent(new GameEvent(GameEvent.RESTART_GAME));
			}
		}
	}
}
