﻿package {

	import com.citrusengine.core.CitrusEngine;

	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.net.URLRequest;

	/**
	 * @author Aymeric
	 */
	public class Main extends CitrusEngine {
		
		private var _level:MovieClip;
		private var _hud:Hud;
		private var _countBricks:uint;

		public function Main() {

			super();

			_hud = new Hud();
			addChild(_hud);

			this.console.addCommand("fullscreen", _fullscreen);
			this.console.addCommand("play", _playGame);

			var loader:Loader = new Loader();
			loader.load(new URLRequest("LevelA.swf"));
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, _levelLoaded);
		}

		private function _levelLoaded(evt:Event):void {

			_level = evt.target.loader.content;
			_restartGame();
			
			evt.target.loader.unloadAndStop();
		}

		private function _fullscreen():void {
			stage.displayState = "fullScreen";
		}

		private function _playGame():void {
			this.playing = !this.playing;
		}

		private function _brickTaken(gEvt:GameEvent):void {

			++_countBricks;
			_hud.scoreCoin = _countBricks;

			if (_countBricks == GameConst.nbrCoins) {
				_restartGame();
			}
		}

		private function _restartGame(gEvt:GameEvent = null):void {

			state = new GameState(_level);

			_hud.scoreCoin = _countBricks = 0;

			state.addEventListener(GameEvent.RESTART_GAME, _restartGame);
			state.addEventListener(GameEvent.TAKE_BRICK, _brickTaken);
		}
	}
}
