package {

	import Box2DAS.Common.V2;
	import Box2DAS.Dynamics.b2Body;
	import Box2DAS.Dynamics.b2BodyDef;

	import com.citrusengine.objects.PhysicsObject;

	import flash.ui.Keyboard;

	/**
	 * @author Aymeric
	 */
	public class Paddle extends PhysicsObject {

		public var acceleration:Number = 1;
		public var maxVelocity:Number = 7;

		private var _friction:Number = 0;
		private var _playerMovingHero:Boolean = false;

		public function Paddle(name:String, params:Object = null) {
			super(name, params);
		}

		override public function update(timeDelta:Number):void {
			
			super.update(timeDelta);

			var velocity:V2 = _body.GetLinearVelocity();

			var moveKeyPressed:Boolean = false;

			if (_ce.input.isDown(Keyboard.RIGHT)) {
				velocity.x += (acceleration);
				moveKeyPressed = true;
			}

			if (_ce.input.isDown(Keyboard.LEFT)) {
				velocity.x -= (acceleration);
				moveKeyPressed = true;
			}

			if (moveKeyPressed && !_playerMovingHero) {
				_playerMovingHero = true;
				_fixture.SetFriction(0);
				// Take away friction so he can accelerate.
			} else if (!moveKeyPressed && _playerMovingHero) {
				_playerMovingHero = false;
				_fixture.SetFriction(_friction);
				// Add friction so that he stops running
			}

			// Cap velocities
			if (velocity.x > (maxVelocity))
				velocity.x = maxVelocity;
			else if (velocity.x < (-maxVelocity))
				velocity.x = -maxVelocity;

			// update physics with new velocity
			_body.SetLinearVelocity(velocity);
		}

		override protected function defineBody():void {
			
			_bodyDef = new b2BodyDef();
			_bodyDef.type = b2Body.b2_kinematicBody;
			_bodyDef.position.v2 = new V2(_x, _y);
			_bodyDef.angle = _rotation;
			_bodyDef.fixedRotation = true;
			_bodyDef.allowSleep = false;
		}

		override protected function defineFixture():void {
			
			super.defineFixture();
			_fixtureDef.friction = _friction;
			_fixtureDef.restitution = 1;
		}

		override protected function createFixture():void {
			
			super.createFixture();
			_fixture.m_reportBeginContact = true;
			_fixture.m_reportEndContact = true;
		}
	}
}
